<?php
/*                                                       */
/* bil_objset.php - Billing object settings              */
/* $ID 8025 - 2023-02-20 - brom $                        */
/*                                                       */
/* BROM CMS/BelCal Project  <http://www.brom-belcal.de> */
/*                                                       */
/* BROM CMS/BelCal is software you can redistribute it  */
/* under the terms the BROM CMS/BelCal license for free */
/* and modify scripts but without warranty. It is not    */
/* redistributable for payment.                          */
/*                                                       */
/* A distribution of payment will be provided            */
/* exclusively by BROM Service see website or send mail. */
/*                                                       */
/* (c) by BROM-Service 2008  (kontakt@brom-belcal.de)    */
/*                                                       */

defined('BC_PATH') OR die(header('Location: ../index.php'));
require_once(BC_PATH.'/lib/functions.php');
require_once(BC_PATH.'/modules/calendar/calc_functions.php');
// We need also the languages from calendar
if(!file_exists(BC_PATH .'/modules/calendar/languages/'.LANGUAGE .'.php')) {
  // no module language file exists for the language set by the user, include default module language file EN.php
  require(BC_PATH .'/modules/calendar/languages/EN.php');
}
else {
  // a module language file exists for the language defined by the user, load it
  require(BC_PATH .'/modules/calendar/languages/'.LANGUAGE .'.php');
}
if(file_exists(BC_PATH .'/modules/calendar/languages/user_'.LANGUAGE .'.php')) {
  require(BC_PATH .'/modules/calendar/languages/user_'.LANGUAGE .'.php');
}

$newfield3 = false;
$newfield4 = false;
$get_fields = $datapdo->query("SHOW FIELDS FROM `".TABLE_PREFIX."res_price_adds`");
while($row = $datapdo->fetchRow($get_fields)){
  if($row[0]=='isold'){ $newfield3 = true; }
}
$get_fields = $datapdo->query("SHOW FIELDS FROM `".TABLE_PREFIX."res_price_more`");
while($row = $datapdo->fetchRow($get_fields)){
  if($row[0]=='isold'){ $newfield4 = true; }
}
if($newfield3 == false){
  $datapdo->query("ALTER TABLE `".TABLE_PREFIX."res_price_adds` ADD `isold` TINYINT(1) NOT NULL");
}
if($newfield4 == false){
  $datapdo->query("ALTER TABLE `".TABLE_PREFIX."res_price_more` ADD `isold` TINYINT(1) NOT NULL");
}

$object_id = 0;
$old_objset = array();
$objline = 0;
if(isset($single_obj) AND is_numeric($single_obj)){ $object_id = $single_obj; }
if(isset($owner) AND is_numeric($owner)){ $owner = $owner; }else{ $owner = 0;}
$query = "SELECT * FROM `".TABLE_PREFIX."resbilling_objset` ORDER BY `object_id`";
if($object_id > 0){ $query = "SELECT * FROM `".TABLE_PREFIX."resbilling_objset` WHERE `object_id`='$object_id'"; }
if($owner > 0 AND $object_id == 0){ $query = "SELECT * FROM `".TABLE_PREFIX."resbilling_objset` WHERE `mandant_id`='$owner' ORDER BY `object_id`"; }
$get_objects = $datapdo->query($query);
if($datapdo->numRows($get_objects)>0){
  while($object = $datapdo->fetchRow($get_objects,false)){
    $oid = $object['object_id'];
    $sid = $object['section_id'];
    // Check first the object is allready in db or delete it from this tab
    if($datapdo->numRows($datapdo->query("SElECT `object_id` FROM `".TABLE_PREFIX."objects` WHERE `object_id`='$oid' LIMIT 0,1"))==0){
      //$datapdo->query("DELETE FROM `".TABLE_PREFIX."resbilling_objset` WHERE `object_id`='$oid' LIMIT 1");
      continue;
    }
    // Check the object is visible
    $visible = $datapdo->get_one("SELECT `visibility` FROM `".TABLE_PREFIX."objects` WHERE `object_id`='$oid' LIMIT 1");
    if($visible=='deleted'){ continue; }
//    array_push($object,'SEASON','HOLI','ADDS','MORES');
    // Check the old detail settings
    $get_seas = $datapdo->query("SELECT `commission_type` FROM `".TABLE_PREFIX."resbilling_obj` WHERE `object_id`='$oid' AND `pricetab_id`='SEASON' LIMIT 0,1");
    if($datapdo->numRows($get_seas)>0){
      $seas = $datapdo->fetchRow($get_seas);
      $object['SEASON'] = $seas['commission_type'];
    }
    else{
      $datapdo->query("INSERT INTO `".TABLE_PREFIX."resbilling_obj` (`object_id`,`section_id`,`pricetab_id`,`commission_type`) VALUES ('$oid','$sid','SEASON','1')");
    }
    $get_holi = $datapdo->query("SELECT `commission_type` FROM `".TABLE_PREFIX."resbilling_obj` WHERE `object_id`='$oid' AND `pricetab_id`='HOLI' LIMIT 0,1");
    if($datapdo->numRows($get_holi)>0){
      $holi = $datapdo->fetchRow($get_holi);
      $object['HOLI'] = $holi['commission_type'];
    }
    else{
      $datapdo->query("INSERT INTO `".TABLE_PREFIX."resbilling_obj` (`object_id`,`section_id`,`pricetab_id`,`commission_type`) VALUES ('$oid','$sid','HOLI','1')");
    }
    // Other price details if available
    $iscalc = $datapdo->get_one("SELECT `calculator` FROM `".TABLE_PREFIX."calendar` WHERE `object_id`='$oid' LIMIT 1");
    $object['haveprice'] = $iscalc;
    if($iscalc == 1){
      $get_mores = $datapdo->query("SELECT `rpmore_id`,`isold` FROM `".TABLE_PREFIX."res_price_more` WHERE `object_id`='$oid' ORDER BY `isold` ASC");
      if($datapdo->numRows($get_mores)>0){
        while($mores = $datapdo->fetchRow($get_mores)){
          $ptid = 'MORE_'.$mores['rpmore_id'];
          $isold = (isset($mores['isold'])?$mores['isold']:0);
//          array_push($object,$ptid);
          $get_more = $datapdo->query("SELECT `commission_type` FROM `".TABLE_PREFIX."resbilling_obj` WHERE `object_id`='$oid' AND `pricetab_id`='$ptid' LIMIT 0,1");
          if($datapdo->numRows($get_more)>0){
            $more = $datapdo->fetchRow($get_more);
            $object['MORES'][$ptid] = array('type'=>$more['commission_type'],'old'=>$isold);
          }
          else{
            $datapdo->query("INSERT INTO `".TABLE_PREFIX."resbilling_obj` (`object_id`,`section_id`,`pricetab_id`) VALUES ('$oid','$sid','$ptid')");
            $object['MORES'][$ptid] = array('type'=>0,'old'=>0);
          }
        }
      }
      $get_adds = $datapdo->query("SELECT `rpadds_id`,`isold`,`addsend` FROM `".TABLE_PREFIX."res_price_adds` WHERE `object_id`='$oid' ORDER BY `isold` ASC, `addsend` DESC");
      if($datapdo->numRows($get_adds)>0){
        while($adds = $datapdo->fetchRow($get_adds)){
          $ptid = 'ADDS_'.$adds['rpadds_id'];
          $isold = (isset($adds['isold'])?$adds['isold']:0);
          $get_add = $datapdo->query("SELECT `commission_type` FROM `".TABLE_PREFIX."resbilling_obj` WHERE `object_id`='$oid' AND `pricetab_id`='$ptid' LIMIT 0,1");
          if($datapdo->numRows($get_add)>0){
            $add = $datapdo->fetchRow($get_add);
            $object['ADDS'][$ptid] = array('type'=>$add['commission_type'],'old'=>$isold);
          }
          else{
            $datapdo->query("INSERT INTO `".TABLE_PREFIX."resbilling_obj` (`object_id`,`section_id`,`pricetab_id`) VALUES ('$oid','$sid','$ptid')");
            $object['ADDS'][$ptid] = array('type'=>0,'old'=>0);
          }
        }
      }
    }
    $old_objset[$objline] = $object;
    $objline++;
  }
}
// Build the output
$tab_output = '';
$obj_output = '';
$cansave = true;
if($objline > 1){
  // Output the tabs for all objects
  $tab_output = '<div class="objtabs">'."\n";
  $tab_output .= '  <ul style="background:transparent;border:0;border-bottom:1px solid #555555;float:left;padding:0;">'."\n";
  foreach($old_objset AS $l => $v){
    $tabid = 'o'.$l;
    $tabname = get_object_title($v['object_id']);
    $tabshort = $admin->zero_to_number($v['object_id'],3);
    $tab_output .= '    <li style="margin:0.5px;padding:0px;"><a href="#'.$tabid.'" title="'.$tabname.'">'.$tabshort.'</a></li>'."\n";
  }
  $tab_output .= '  </ul><br />'."\n";
}
$adr_order = $datapdo->get_one("SELECT `adr_sort` FROM `".TABLE_PREFIX."users` WHERE `user_id`='$user_id' LIMIT 1");
switch ($adr_order){
    case 1:
      $sort_by = "`prename`,`name`,`city`";
      break;
    case 2:
      $sort_by = "`city`,`name`,`prename`";
      break;
    case 3:
    default:
      $sort_by = "`name`,`prename`,`city`";
}
if($objline > 0){
  foreach($old_objset AS $line => $oval){
    $tabname = get_object_title($oval['object_id']);
    $obj_output .= '<div id="o'.$line.'">'."\n";
    $obj_output .= '<h2>'.$tabname.'</h2>'."\n";
    $obj_output .= '<input type="hidden" name="currobject'.$oval['object_id'].'" value="1" />';
    $obj_output .= '<table width="100%" cellspacing="2" cellpadding="2" border="0">'."\n";
    $obj_output .= '<tr><td class="setting_name">'.$TEXT['OWNER'].':</td><td class="setting_value">';
    $obj_output .= '<select name="mandant_id'.$oval['object_id'].'">';
    $obj_output .= '<option value="0"'.($oval['mandant_id']==0?' selected="selected"':'').'>'.$TEXT['PLEASE_SELECT'].'</option>';
    $get_adr = $datapdo->query("SELECT `address_id`,`adr_type` FROM `".TABLE_PREFIX."address` ORDER BY $sort_by");
    while($adr = $datapdo->fetchRow($get_adr)){
      $isadr = false;
      $adr_types = explode('|',$adr['adr_type']);
      foreach($adr_types AS $atK => $atV){
        if($atV > 1){ $isadr = true; }
      }
      if($isadr == true){
        $mid = $adr['address_id'];
        $adr_details = $admin->get_adr_complate($mid);
        $adr_details = preg_replace('/\<br\s\/>/',' - ',$adr_details);
        if($adr_order == 3){ $adr_details = $admin->get_client_id($mid).' - '.$adr_details; }
        $obj_output .= '<option value="'.$mid.'"'.($oval['mandant_id']==$mid?' selected="selected"':'').'>'.$adr_details.'</option>';
      }
    }
    $obj_output .= '</select>';
    $obj_output .= '</td></tr>'."\n";
    $obj_output .= '<tr><td class="setting_name">'.$TEXT['OBJECT'].'-'.$TEXT['ADDRESS'].'/'.$TEXT['LOCATION'].':</td><td class="setting_value">';
    $obj_output .= '<input type="text" name="location'.$oval['object_id'].'" value="'.$oval['location'].'" />';
    $obj_output .= '</td></tr>'."\n";
    $obj_output .= '<tr><td class="setting_name">'.$TEXT['BIL'].'-'.$TEXT['TYPE'].':</td><td>';
    $disabled = ($oval['haveprice']==1?'':' disabled');
    $obj_output .= '<input type="radio" id="tpl'.$oval['object_id'].'a" name="tpl'.$oval['object_id'].'" value="0"'.(($oval['tpl']==0)?' checked="checked"':'').' onclick="set_tpl(\'o'.$oval['object_id'].'\',0);$(\'#SEASON'.$oval['object_id'].'\').val(\'0\');" />';
    $obj_output .= '<label for="tpl'.$oval['object_id'].'a">'.$TEXT['NONE'].'</label>&nbsp;&nbsp;';
    $obj_output .= '<input'.$disabled.' type="radio" id="tpl'.$oval['object_id'].'b" name="tpl'.$oval['object_id'].'" value="1"'.(($oval['tpl']==1 AND $disabled=='')?' checked="checked"':'').' onclick="set_tpl(\'o'.$oval['object_id'].'\',1);$(\'#SEASON'.$oval['object_id'].'\').val(\'1\');" />';
    $obj_output .= '<label for="tpl'.$oval['object_id'].'b">'.$TEXT['RESBILLING_PRICE'].'</label>&nbsp;&nbsp;';
    $obj_output .= '<input type="radio" id="tpl'.$oval['object_id'].'c" name="tpl'.$oval['object_id'].'" value="2"'.(($oval['tpl']==2 OR ($oval['tpl']>0 AND !empty($disabled)))?' checked="checked"':'').' onclick="set_tpl(\'o'.$oval['object_id'].'\',2);$(\'#SEASON'.$oval['object_id'].'\').val(\'0\');" />';
    $obj_output .= '<label for="tpl'.$oval['object_id'].'c">'.$TEXT['ONLY'].' '.$TEXT['RESBILLING_NOTPRICE'].'</label>';
    $obj_output .= '</td></tr>'."\n";
    $obj_output .= '</table>'."\n";
    // Output the no price settings or package prices
    $class2 = ($oval['tpl']==0?' class="hide"':'');
    $obj_output .= '<table'.$class2.' id="o'.$oval['object_id'].'tpl_2" width="100%" cellspacing="2" cellpadding="2" border="0">'."\n";
    $obj_output .= '<tr><td class="setting_name">'.$TEXT['COMMISSION'].' '.$TEXT['RESBILLING_NOTPRICE_SHORT'].':</td><td class="setting_value50">';
    $obj_output .= '<input type="text" id="commission_pack'.$oval['object_id'].'" name="commission_pack'.$oval['object_id'].'" value="'.number_format($oval['commission_pack'],2,$dec_point,$thousends).'" onchange=checknumformat(this,2);" style="text-align:right;" />';
    $punit = $oval['commission_unit'];
    $obj_output .= '&nbsp;<select name="commission_unit'.$oval['object_id'].'" style="width:50px">';
    foreach($TEXT['PRICE_UNIT'] AS $unitkey => $unitval){
      if($unitkey == 'NAME'){ continue; }
      $obj_output .= '<option value="'.$unitkey.'"'.($oval['commission_unit']==$unitkey?' selected="selected"':'').'>'.$unitval.'</option>';
    }
    $obj_output .= '</select><td>';
    $obj_output .= '<td><select name="commission_packtype'.$oval['object_id'].'" style="width:40%;">';
    $obj_output .= '<option value="0"'.($oval['commission_packtype']==0?' selected="selected"':'').'>'.$TEXT['PER'].' '.$TEXT['YEAR'].'</option>';
    $obj_output .= '<option value="1"'.($oval['commission_packtype']==1?' selected="selected"':'').'>'.$TEXT['PER'].' '.$TEXT['YEAR_HALF'].'</option>';
    $obj_output .= '<option value="2"'.($oval['commission_packtype']==2?' selected="selected"':'').'>'.$TEXT['PER'].' '.$TEXT['YEAR_QUART'].'</option>';
    $obj_output .= '<option value="3"'.($oval['commission_packtype']==3?' selected="selected"':'').'>'.$TEXT['PER'].' '.$TEXT['MONTH'].'</option>';
    $obj_output .= '<option value="4"'.($oval['commission_packtype']==4?' selected="selected"':'').'>'.$TEXT['PER'].' '.$TEXT['RESERVATION'].'</option>';
    $obj_output .= '<option value="5"'.($oval['commission_packtype']==5?' selected="selected"':'').'>'.$TEXT['PER'].' '.$TEXT['RESERVATION'].'-'.$TEXT['DAY'].'</option>';
    $obj_output .= '</select>&nbsp;';
    $obj_output .= $TEXT['FROM'].'&nbsp;<input type="text" id="commission_packfirst'.$oval['object_id'].'" name="commission_packfirst'.$oval['object_id'].'" value="'.((isset($oval['commission_packfirst']) AND $oval['commission_packfirst']>0)?date($jscal_format,$oval['commission_packfirst']):'').'" style="width:35%;" />'."\n";
    if(isset($jscal_loaded) AND $jscal_loaded == true){
      $jscal_dates[] = 'commission_packfirst'.$oval['object_id'];
      $obj_output .= '<img src="'.$jscal_button.'" id="trigger_commission_packfirst'.$oval['object_id'].'" class="jscal_btn" title="'.$TEXT['CALENDAR'].'" onmouseover="this.style.background=\''.$jscal_btn_hover.'\';" onmouseout="this.style.background=\'\'">';
    }
    $obj_output .= '</td></tr>'."\n";
    $obj_output .= '</table>'."\n";
    $class1 = ($oval['tpl']==1?'':' class="hide"');
    // Output the price settings
    $obj_output .= '<table'.$class1.' id="o'.$oval['object_id'].'tpl_1" width="100%" cellspacing="2" cellpadding="2" border="0">'."\n";
    $obj_output .= '<tr><td class="setting_name">'.$TEXT['COMMISSION'].' '.$TEXT['RESBILLING_PRICE_SHORT'].':</td><td class="setting_value50">';
    $obj_output .= '<input type="text" id="commission'.$oval['object_id'].'" name="commission'.$oval['object_id'].'" value="'.$oval['commission'].'" onchange=checknumformat(this,0);" style="text-align:right;" /> %</td>';
    $obj_output .= '<td><input type="hidden" id="SEASON'.$oval['object_id'].'" name="SEASON_'.$oval['object_id'].'" value="'.($oval['tpl']==1?1:$oval['SEASON']).'" /></td></tr>'."\n";
    $obj_output .= '<tr><td class="setting_name">'.$TEXT['COMMISSION'].' '.$TEXT['RESBILLING_PRICE_STORNO'].':</td><td class="setting_value50">';
    $obj_output .= '<input type="text" id="commission_storno'.$oval['object_id'].'" name="commission_storno'.$oval['object_id'].'" value="'.$oval['commission_storno'].'" onchange=checknumformat(this,0);" style="text-align:right;" /> %<td></tr>';
    $obj_output .= '<tr><td colspan="3"><h3>'.$TEXT['HANDLING'].' '.$TEXT['OF'].' '.$TEXT['SURCHARGES'].'</h3></td></tr>';
    $obj_output .= '<tr><td colspan="2" valign="top">'."\n";
    $obj_output .= '<table width="100%" cellspacing="2" cellpadding="2" border="0">'."\n";
    $obj_output .= '<tr><th class="setting_name">'.$CALTEXT['PRICES_ADDS'].'</th><th class="setting_value50">'.$TEXT['COMMISSION'].'</th>';
    $obj_output .= '<tr><td class="setting_name">'.$TEXT['HOLI_DAYS'].'</td><td class="setting_value50">';
    $obj_output .= '<input type="radio" id="holi'.$oval['object_id'].'true" name="HOLI_'.$oval['object_id'].'" value="1"'.($oval['HOLI']==1?' checked="checked"':'').'" />';
    $obj_output .= '<label for="holi'.$oval['object_id'].'true">'.$TEXT['YES'].'</label>';
    $obj_output .= '<input type="radio" id="holi'.$oval['object_id'].'false" name="HOLI'.$oval['object_id'].'" value="0"'.($oval['HOLI']==0?' checked="checked"':'').'" />';
    $obj_output .= '<label for="holi'.$oval['object_id'].'false">'.$TEXT['NO'].'</label>';
    $obj_output .= '</td></tr>'."\n";
    $footnote = '';
    if(isset($oval['ADDS'])){
      foreach($oval['ADDS'] AS $addn => $addvalarray){
        $addval = $addvalarray['type'];
        $oldadd = ($addvalarray['old']==1?true:false);
        $addid = str_replace('ADDS_','',$addn);
//        $get_addname_array = $datapdo->get_one("SELECT `adds_name` FROM `".TABLE_PREFIX."res_price_adds` WHERE `rpadds_id`='$addid' LIMIT 1");
//        $addname_array = unserialize($get_addname_array);
        $addname = get_name_addkey($addid,'adds',$oval['section_id']);
//        $addname = (isset($addname_array[LANGUAGE])?$addname_array[LANGUAGE]:$addname_array[DEFAULT_LANGUAGE]);
        $obj_output .= '<tr'.($oldadd==true?' class="row_a"':'').'><td class="setting_name">'.$addname.'</td><td class="setting_value50">';
        $obj_output .= '<input type="radio" id="'.$addn.'_'.$oval['object_id'].'true" name="'.$addn.'_'.$oval['object_id'].'" value="1"'.($addval==1?' checked="checked"':'').'" />';
        $obj_output .= '<label for="'.$addn.'_'.$oval['object_id'].'true">'.$TEXT['YES'].'</label>';
        $obj_output .= '<input type="radio" id="'.$addn.'_'.$oval['object_id'].'false" name="'.$addn.'_'.$oval['object_id'].'" value="0"'.($addval==0?' checked="checked"':'').'" />';
        $obj_output .= '<label for="'.$addn.'_'.$oval['object_id'].'false">'.$TEXT['NO'].'</label>';
        if($oldadd==true){ $footnote = '<p>*) '.$CALTEXT['FILTER_OLD'].' '.$TEXT['TERMINS']; }
        $obj_output .= ($oldadd==true?' *)':'');
        $obj_output .= '</td></tr>'."\n";
      }
    }
    $obj_output .= '</table></td><td valign="top">'."\n";
    $obj_output .= '<table width="100%" cellspacing="2" cellpadding="2" border="0">'."\n";
    $obj_output .= '<tr><th class="setting_name">'.$CALTEXT['PRICES_MORES'].'</th><th class="setting_value50">'.$TEXT['COMMISSION'].'</th>';
//    $pmore_array = array();
//    $pmore_rpmoreIDs = array();
//    $formobj = $datapdo->get_one("SELECT `form_object` FROM `".TABLE_PREFIX."calendar` WHERE `object_id`='".$oval['object_id']."' LIMIT 1");
    if(isset($oval['MORES'])){
      foreach($oval['MORES'] AS $moren => $morevalarray){
        $moreid = str_replace('MORE_','',$moren);
        $moreval = $morevalarray['type'];
        $oldmore = ($morevalarray['old']==1?true:false);
        $morename = get_name_addkey($moreid,'more',$oval['section_id']);
        $obj_output .= '<tr'.($oldmore==true?' class="row_a"':'').'><td class="setting_name">'.$morename.'</td><td class="setting_value50">';
        $obj_output .= '<input type="radio" id="'.$moren.'_'.$oval['object_id'].'true" name="'.$moren.'_'.$oval['object_id'].'" value="1"'.($moreval==1?' checked="checked"':'').'" />';
        $obj_output .= '<label for="'.$moren.'_'.$oval['object_id'].'true">'.$TEXT['YES'].'</label>';
        $obj_output .= '<input type="radio" id="'.$addn.'_'.$oval['object_id'].'false" name="'.$moren.'_'.$oval['object_id'].'" value="0"'.($moreval==0?' checked="checked"':'').'" />';
        $obj_output .= '<label for="'.$moren.'_'.$oval['object_id'].'false">'.$TEXT['NO'].'</label>';
        if($oldmore==true){ $footnote = '<p>*) '.$CALTEXT['FILTER_OLD'].' '.$TEXT['TERMINS']; }
        $obj_output .= ($oldmore==true?' *)':'');
        $obj_output .= '</td></tr>'."\n";
      }
    }
    $obj_output .= '</table></td></tr></table>'."\n";
    $obj_output .= $footnote.'</p>';
    $obj_output .= '</div>'."\n";
  }
  $obj_output .= '</div>'."\n";
}
else{ $obj_output = $MESSAGE['OBJECTS']['NOT_FOUND']; $cansave = false; }
if($cansave == true){
  echo '<form name="objset" action="'.ADMIN_URL.'/resbilling/bil_objsave.php" method="post">'."\n";
  echo '<input type="hidden" name="nextact" value="'.$nextact.'" />'."\n";
  echo '<input type="hidden" name="bilaction" value="'.$act.'" />'."\n";
  $backquery = '?bilaction='.$nextact;
  if($objline==1){
    echo '<input type="hidden" name="object_id" value="'.$object_id.'" />'."\n";
    $backquery .= ARGSOJS.'object_id='.$object_id;
  }
  if(isset($owner) AND $owner>0){
    echo '<input type="hidden" name="owner" value="'.$owner.'" />'."\n";
    $backquery .= ARGSOJS.'owner='.$owner;
  }
  echo $tab_output.$obj_output;
  echo '<table width="100%" cellspacing="2" cellpadding="2" border="0">'."\n";
  echo '<tr><td style="width:33%;text-align:left;">';
  echo '<input name="back" type="button" value="'.$TEXT['BACK'].'" style="width:98%" onclick="window.location = \''.ADMIN_URL.'/resbilling/index.php'.$backquery.'\';" />';
  echo '</td><td style="width:34%;text-align:center;">';
  echo '<input name="submit" type="submit" value="'.$TEXT['SAVE'].'" style="width:98%" />';
  echo '</td><td style="width:33%;text-align:right;">';
  echo '<input name="help" type="button" value="'.$MENU['HELP'].'" style="width:98%" onclick="window.location = \''.ADMIN_URL.'/resbilling/help.php'.$backquery.'#object_settings\';" />';
  echo '</td></tr></table>'."\n";
  echo '</form>'."\n";
  if(isset($jscal_loaded) AND $jscal_loaded == true){
    $jscal_include_script = str_replace('cal.hide()','cal.hide();set_new_days()',$jscal_include_script);
    echo $jscal_include_script;
    echo '<script type="text/javascript">'."\n";
    foreach($jscal_dates as $mydate_field){
      echo 'cal.manageFields("trigger_'.$mydate_field.'", "'.$mydate_field.'", "'.$jscal_ifformat.'");'."\n";
    }
    echo '</script>'."\n";
  }
}
else{ $admin->print_error($obj_output,ADMIN_URL.'/objects/index.php',false); }
?>