<?php
/*                                                       */
/* index.php - Reservation billing for administration    */
/* $ID 8020 - 2024-01-04 - brom $                        */
/*                                                       */
/* BROM CMS/BelCal Project  <http://www.brom-belcal.de> */
/*                                                       */
/* BROM CMS/BelCal is software you can redistribute it  */
/* under the terms the BROM CMS/BelCal license for free */
/* and modify scripts but without warranty. It is not    */
/* redistributable for payment.                          */
/*                                                       */
/* A distribution of payment will be provided            */
/* exclusively by BROM Service see website or send mail. */
/*                                                       */
/* (c) by BROM-Service 2008  (kontakt@brom-belcal.de)    */
/*                                                       */

require('../../config/config.php');

require_once(BC_PATH.'/lib/classes/class.admin.php');
$admin = new admin('Billing','resbilling','system');
/*
if(!preg_match('/resbilling/',$_SERVER['HTTP_REFERER'])){
  $_SESSION['COMFROM_URL']=$_SERVER['HTTP_REFERER'];
}
*/
//$backurl=$_SESSION['COMFROM_URL'];
// Include the scripts for PopUp calendar and numberformat
$dec_point = ',';
$thousends = '.';
if(LANGUAGE == 'EN'){ $dec_point = '.'; $thousends = ','; }
// Include the PopUp-Calendar if availlable
if(file_exists(BC_PATH.'/lib/include/jscalendar/jscal-setup.php')){
  $jscal_use_time = false; // whether to use a clock, too
  $jscal_type = 'backend';
  require(BC_PATH.'/lib/include/jscalendar/jscal-setup.php');
}
$chktabs = $datapdo->query("SHOW TABLES LIKE '".TABLE_PREFIX."resbilling%'");
if($datapdo->numRows($chktabs) < 8){
  require(ADMIN_PATH.'/resbilling/first_settings.php');
}
// check the field deleted in ressbilling detail
$isfield = array('deleted'=>false,'commission_storno'=>false,'received'=>false,'label_other'=>false,'other_price'=>false,'label_other2'=>false,'other_price2'=>false,'old_number'=>false,'commission_pack'=>false,'old_date'=>false);
$get_fields = $datapdo->query("SHOW FIELDS FROM `".TABLE_PREFIX."resbilling_detail`");
while($row = $datapdo->fetchRow($get_fields)){
  if($row[0]=='deleted'){ $isfield['deleted'] = true; }
  if($row[0]=='received'){ $isfield['received'] = true; }
  if($row[0]=='label_other'){ $isfield['label_other'] = true; }
  if($row[0]=='other_price'){ $isfield['other_price'] = true; }
}
$get_fields = $datapdo->query("SHOW FIELDS FROM `".TABLE_PREFIX."resbilling_sdetail`");
while($row = $datapdo->fetchRow($get_fields)){
  if($row[0]=='label_other'){ $isfield['label_other2'] = true; }
  if($row[0]=='other_price'){ $isfield['other_price2'] = true; }
  if($row[0]=='commission_pack'){ $isfield['commission_pack'] = true; }
  if($row[0]=='old_date'){ $isfield['old_date'] = true; }
}
$get_fields = $datapdo->query("SHOW FIELDS FROM `".TABLE_PREFIX."resbilling_objset`");
while($row = $datapdo->fetchRow($get_fields)){
  if($row[0]=='commission_storno'){ $isfield['commission_storno'] = true; }
}
$get_fields = $datapdo->query("SHOW FIELDS FROM `".TABLE_PREFIX."resbilling_storno`");
while($row = $datapdo->fetchRow($get_fields)){
  if($row[0]=='old_number'){ $isfield['old_number'] = true; }
}
foreach($isfield AS $fld => $vfld){
  if($vfld == true){ continue; }
  switch ($fld){
    case 'received':
      $datapdo->query("ALTER TABLE `".TABLE_PREFIX."resbilling_detail` ADD `received` DECIMAL(10,2) NOT NULL AFTER `commission`");
      break;
    case 'other_price':
      $datapdo->query("ALTER TABLE `".TABLE_PREFIX."resbilling_detail` ADD `other_price` DECIMAL(10,2) NOT NULL AFTER `commission`");
      break;
    case 'label_other':
      $datapdo->query("ALTER TABLE `".TABLE_PREFIX."resbilling_detail` ADD `label_other` VARCHAR(255) NOT NULL AFTER `commission`");
      break;
    case 'other_price2':
      $datapdo->query("ALTER TABLE `".TABLE_PREFIX."resbilling_sdetail` ADD `other_price` DECIMAL(10,2) NOT NULL AFTER `commission`");
      break;
    case 'label_other2':
      $datapdo->query("ALTER TABLE `".TABLE_PREFIX."resbilling_sdetail` ADD `label_other` VARCHAR(255) NOT NULL AFTER `commission`");
      break;
    case 'commission_pack':
      $datapdo->query("ALTER TABLE `".TABLE_PREFIX."resbilling_sdetail` ADD `commission_pack` DECIMAL(10,2) NOT NULL AFTER `commission`");
      break;
    case 'old_date':
      $datapdo->query("ALTER TABLE `".TABLE_PREFIX."resbilling_sdetail` ADD `old_date` INT NOT NULL");
      break;
    case 'deleted':
      $datapdo->query("ALTER TABLE `".TABLE_PREFIX."resbilling_detail` ADD `deleted` TINYINT(1) NOT NULL");
      break;
    case 'commission_storno':
      $datapdo->query("ALTER TABLE `".TABLE_PREFIX."resbilling_objset` ADD `commission_storno` TINYINT(2) NOT NULL");
      break;
    case 'old_number':
      $datapdo->query("ALTER TABLE `".TABLE_PREFIX."resbilling_storno` ADD `old_number` VARCHAR(15) NOT NULL DEFAULT '' AFTER `bil_number`");
      // Get is old namber in sdetail
      $habefield = false;
      $get_fields = $datapdo->query("SHOW FIELDS FROM `".TABLE_PREFIX."resbilling_sdetail`");
      while($row = $datapdo->fetchRow($get_fields)){
        if($row[0]=='old_number'){ $habefield = true; }
      }
      if($havefield == false){
        $datapdo->query("ALTER TABLE `".TABLE_PREFIX."resbilling_sdetail` ADD `old_number` VARCHAR(15) NOT NULL DEFAULT ''");
      }
      // Fill all old numbers like storno details
      $get_sbillings = $datapdo->query("SELECT `sbilling_id` FROM `".TABLE_PREFIX."resbilling_storno`");
      if($datapdo->numRows($get_sbillings)>0){
        while($sbillings = $datapdo->fetchRow($get_sbillings)){
          $sbilid = $sbillings['sbilling_id'];
          $oldnumber = $datapdo->get_one("SELECT `old_number` FROM `".TABLE_PREFIX."resbilling_sdetail` WHERE `sbilling_id`='$sbilid' LIMIT 1");
          $datapdo->query("UPDATE `".TABLE_PREFIX."resbilling_storno` SET `old_number`='$oldnumber' WHERE `sbilling_id`='$sbilid' LIMIT 1");
        }
      }
      break;
  }
}
// Set new fields for adds and more
$newfield3 = false;
$newfield4 = false;
$get_fields = $datapdo->query("SHOW FIELDS FROM `".TABLE_PREFIX."res_price_adds`");
while($row = $datapdo->fetchRow($get_fields)){
  if($row[0]=='isold'){ $newfield3 = true; }
}
$get_fields = $datapdo->query("SHOW FIELDS FROM `".TABLE_PREFIX."res_price_more`");
while($row = $datapdo->fetchRow($get_fields)){
  if($row[0]=='isold'){ $newfield4 = true; }
}
if($newfield3 == false){
  $datapdo->query("ALTER TABLE `".TABLE_PREFIX."res_price_adds` ADD `isold` TINYINT(1) NOT NULL");
}
if($newfield4 == false){
  $datapdo->query("ALTER TABLE `".TABLE_PREFIX."res_price_more` ADD `isold` TINYINT(1) NOT NULL");
}

?>
<script type="text/javascript">
$(document).ready(function(){
     if($('.objtabs').length){ $('.objtabs').tabs(); }
     if($('.tabs').length){
        $('.tabs').tabs({
           activate: function( event, ui ) {
              var tabid = ui.newPanel.selector;
              var taburl = "<?php echo ADMIN_URL.'/resbilling/loadlisttab.php?id='; ?>"+tabid.substr(2,4);
              $(tabid).load(taburl);
           }
        });
     }
});
function checknumformat(elem,decs){
     var p = elem.value;
     elem.value = checkformat(p,decs);
};
function checkformat(x,z){
     dec_point = '<?php echo $dec_point; ?>';
     thousends = '<?php echo $thousends; ?>';
     var negativ = '';
     if(x.substr(0,1)=='-'){
         x = x.substr(1,x.length);
         negativ = '-';
     }
     x_array = x.split(dec_point);
     if(!x_array[0]){
         x1 = '0';
     }
     else{
         x1 = x_array[0];
         x1 = x1.replace(/[\.|\,]/g,'');
     }
     if(!x_array[1]){
         if(x1.length > 4){
             x2 = x1.substr(x1.length-2,x1.length);
             x1 = x1.substr(0,x1.length-2);
         }
         else{
             x2 = '00';
         }
     }
     else{
         x2 = x_array[1];
     }
     if(x2.length < 2){
         x2 = x2 + '0';
     }
     if(x1.length > 6){
         x1 = x1.substr(0,6);
     }
     if(x1.length > 3){
         x1 = x1.substr(0,x1.length -3 ) + thousends + x1.substr(x1.length -3,x1.length);
     }
     if(z > 0){ return negativ + x1 + dec_point + x2.substr(0,z); }
     else{ return negativ + x1; }
};
function set_tpl(o,t){
     var elemid1 = "#" + o + "tpl_1";
     var elemid2 = "#" + o + "tpl_2";
     if(t==0){
        $(elemid1).hide();
        $(elemid2).hide();
     }
     else if(t==1){
       $(elemid1).show();
       $(elemid2).show();
     }
     else{
       $(elemid1).hide();
       $(elemid2).show();
     }
};
</script>
<?php
// Update db for resbilling storno in version 3.993 if not exists
// Ceck the tpl3 is saved or add this
$is_tpl3 = $datapdo->numRows($datapdo->query("SELECT `templ_id` FROM `".TABLE_PREFIX."resbilling_tpl` WHERE `tpl_id`='3' LIMIT 0,1"));
if($is_tpl3 == 0){
  require(ADMIN_PATH.'/resbilling/default_tpl.php');
  foreach($deftpl3 AS $lang => $values){
    $top_header = $values['top_header'];
    $bil_header = $values['bil_header'];
    $loop_tabheader = $values['loop_tabheader'];
    $loop_header = $values['loop_header'];
    $loop1 = $values['loop1'];
    $loop2 = $values['loop2'];
    $loop_footer = $values['loop_footer'];
    $loop_tabfooter = $values['loop_tabfooter'];
    $bil_footer = $values['bil_footer'];
    $bottom_footer = $values['bottom_footer'];
    $payment_info_credit = $values['payment_info_credit'];
    $filltp3 = "INSERT INTO `".TABLE_PREFIX."resbilling_tpl` "
		    ."(`tpl_id`,`language`,`top_header`,`bil_header`,`loop_tabheader`,`loop_header`,`loop1`,`loop2`,`loop_footer`,`loop_tabfooter`,`bil_footer`,`bottom_footer`,`payment_info_credit`) VALUES "
		    ."('3','$lang','$top_header','$bil_header','$loop_tabheader','$loop_header','$loop1','$loop2','$loop_footer','$loop_tabfooter','$bil_footer','$bottom_footer','$payment_info_credit')";
    $datapdo->query($filltp3);
  }
}
$chk_fiefds = array('deleted'=>0,'storno_commission'=>0,'commission_vat'=>0);
$get_fields = $datapdo->query("SHOW FIELDS FROM `".TABLE_PREFIX."resbilling_storno`");
while($row = $datapdo->fetchRow($get_fields)){
  if($row[0]=='storno_commission'){ $chk_fields['storno_commission'] = 1; }
  if($row[0]=='commission_vat'){ $chk_fields['commission_vat'] = 1; }
}
$get_fields = $datapdo->query("SHOW FIELDS FROM `".TABLE_PREFIX."resbilling_detail`");
while($row = $datapdo->fetchRow($get_fields)){
  if($row[0]=='deleted'){ $chk_fields['deleted'] = 1; }
}
foreach($chk_fields AS $fld_key => $fld_value){
  if($fld_value == 1){ continue; }
  switch ($fld_key){
    case 'storno_commission':
      $datapdo->query("ALTER TABLE `".TABLE_PREFIX."resbilling_storno` ADD `storno_commission` DECIMAL(10,2) NOT NULL");
      break;
    case 'commission_vat':
      $datapdo->query("ALTER TABLE `".TABLE_PREFIX."resbilling_storno` ADD `commission_vat` DECIMAL(8,2) NOT NULL");
      break;
    case 'deleted':
      $datapdo->query("ALTER TABLE `".TABLE_PREFIX."resbilling_detail` ADD `deleted` TINYINT(1) NOT NULL");
      break;
  }
}
// Output the top header
$user_id = $admin->get_user_id();
$act = 0;
$storno_id = 0;
$billing_id = 0;
$singleres_id = 0;
$nextact = 0;
$single_obj = 0;
$owner = 0;
$res_ids = array();
$skippedres = 0;
// Get the queries
if(isset($_GET['billing_id']) AND is_numeric($_GET['billing_id'])){ $billing_id = $admin->get_get('billing_id'); }
if(isset($_GET['bilaction']) AND is_numeric($_GET['bilaction'])){ $act = $admin->get_get('bilaction'); }
if(isset($_GET['storno']) AND is_numeric($_GET['storno'])){ $storno_id = $admin->get_get('storno'); }
if(isset($_GET['singleres']) AND is_numeric($_GET['singleres'])){ $singleres_id = $admin->get_get('singleres'); }
if(isset($_GET['nextact']) AND is_numeric($_GET['nextact'])){ $nextact = $admin->get_get('nextact'); }
if(isset($_GET['object_id']) AND is_numeric($_GET['object_id'])){ $single_obj = $admin->get_get('object_id'); }
if(isset($_GET['owner']) AND is_numeric($_GET['owner'])){ $owner = $admin->get_get('owner'); }
if(isset($_SESSION['COMMISSION_RES'])){ $res_ids = $_SESSION['COMMISSION_RES']; }
if($singleres_id > 0){
  $res_ids = array($singleres_id=>'on');
  $_SESSION['COMMISSION_RES'] = $res_ids;
}
// Check the status is not 4 or 5
foreach($res_ids AS $r => $rv){
  if($datapdo->numRows($datapdo->query("SELECT `res_id` FROM `".TABLE_PREFIX."reservations` WHERE `res_id`='$r' AND `status`>'3' LIMIT 0,1"))>0){
    unset($res_ids[$r]);
    $skippedres++;
  }
}

$errorres = ($skippedres >0?$skippedres.' '.$TEXT['SELECTED'].' '.strtolower($MESSAGE['UPDATE']['SKIPPED']).'<br />':'');
$notabs = $datapdo->query("SHOW TABLES LIKE '".TABLE_PREFIX."resbilling'");
if($datapdo->numRows($notabs)>0){
  // Check first all objects are configured or insert them as new (only if not first settings
  $get_cals = $datapdo->query("SELECT `object_id`,`section_id` FROM `".TABLE_PREFIX."sections` WHERE `module`='calendar'");
  while($cals = $datapdo->fetchRow($get_cals)){
    $o = $cals['object_id'];
    $s = $cals['section_id'];
    $is_objset = $datapdo->numRows($datapdo->query("SELECT `bilobjset_id` FROM `".TABLE_PREFIX."resbilling_objset` WHERE `object_id`='$o'"));
    if($is_objset > 0){ continue; }
    // Get the settings of owner and location this object for default inserts
    $get_objset = $datapdo->query("SELECT o.`owner`,ot.`location` FROM `".TABLE_PREFIX."objects` AS o,`".TABLE_PREFIX."obj_texts` AS ot WHERE o.`object_id`='$o' AND ot.`object_id`=o.`object_id` AND ot.`language`=o.`default_language` LIMIT 1");
    $objset = $datapdo->fetchRow($get_objset);
    if($objset['owner']>1){ $adrid = $datapdo->get_one("SELECT `address_id` FROM `".TABLE_PREFIX."address` WHERE `user_id`='".$objset['owner']."' LIMIT 1"); }
    else{ $adrid = 0; }
    $location = $objset['location'];
    // Check we have prices this object
    $priceset = $datapdo->get_one("SELECT `calculator` FROM `".TABLE_PREFIX."calendar` WHERE `object_id`='$o' LIMIT 1");
    if($priceset == 1){
      $datapdo->query("INSERT INTO `".TABLE_PREFIX."resbilling_objset` (`object_id`,`section_id`,`mandant_id`,`location`,`tpl`) VALUES ('$o','$s','$adrid','$location','1')");
      $datapdo->query("INSERT INTO `".TABLE_PREFIX."resbilling_obj` (`object_id`,`section_id`,`pricetab_id`,`commission_type`) VALUES ('$o','$s','SEASON','1')");
      $datapdo->query("INSERT INTO `".TABLE_PREFIX."resbilling_obj` (`object_id`,`section_id`,`pricetab_id`,`commission_type`) VALUES ('$o','$s','HOLI','1')");
      $get_mores = $datapdo->query("SELECT `rpmore_id` FROM `".TABLE_PREFIX."res_price_more` WHERE `object_id`='$o'");
      if($datapdo->numRows($get_mores)>0){
        while($more = $datapdo->fetchRow($get_mores)){
          $pricetab_id = 'MORE_'.$more['rpmore_id'];
          $datapdo->query("INSERT INTO `".TABLE_PREFIX."resbilling_obj` (`object_id`,`section_id`,`pricetab_id`) VALUES ('$o','$s','$pricetab_id')");
        }
      }
      $get_adds = $datapdo->query("SELECT `rpadds_id` FROM `".TABLE_PREFIX."res_price_adds` WHERE `object_id`='$o'");
      if($datapdo->numRows($get_adds)>0){
        while($adds = $datapdo->fetchRow($get_adds)){
          $pricetab_id = 'ADDS_'.$adds['rpadds_id'];
          $datapdo->query("INSERT INTO `".TABLE_PREFIX."resbilling_obj` (`object_id`,`section_id`,`pricetab_id`) VALUES ('$o','$s','$pricetab_id')");
        }
      }
    }
    else{
      // Add the object without prices
      $datapdo->query("INSERT INTO `".TABLE_PREFIX."resbilling_objset` (`object_id`,`section_id`,`mandant_id`,`location`,`tpl`) VALUES ('$o','$s','$adrid','$location','2')");
      $datapdo->query("INSERT INTO `".TABLE_PREFIX."resbilling_obj` (`object_id`,`section_id`,`pricetab_id`,`commission_type`) VALUES ('$o','$s','SEASON','0')");
      $datapdo->query("INSERT INTO `".TABLE_PREFIX."resbilling_obj` (`object_id`,`section_id`,`pricetab_id`,`commission_type`) VALUES ('$o','$s','HOLI','0')");
    }
  }
  if($datapdo->is_error()){ $admin->print_error($TEXT['ERROR'].' '.$datapdo->get_error(),ADMIN_URL.'/objects/index.php'); }
}
else{
  // Get first settings
  require(ADMIN_PATH.'/resbilling/first_settings.php');
  $act = 8;
}
if($act < 8){ include(ADMIN_PATH.'/resbilling/head_buttons.php'); }

switch ($act){
  case 8:
    // Get all global settings
    $nextact = 3;
    $single_obj = 0;
    $owner = 0;
  case 7:
    // Get vat global settings
  case 6:
    // Get oporator global settings
  case 5:
    // Get template global settings
  case 4:
    // Output the settings page
    echo '<h2>'.$TEXT['RESBILLING'].' - '.$TEXT['MAIN_SETTINGS'].'</h2>'."\n";
    include(ADMIN_PATH.'/resbilling/main_settings.php');
    break;
  case 3:
    // Get object settings
    echo '<h2>'.$TEXT['RESBILLING'].' - '.$MENU['OBJECTS'].'</h2>'."\n";
    include(ADMIN_PATH.'/resbilling/bil_objset.php');
    break;
  case 2:
    if($storno_id>0){
      // Get storno billing
      include(ADMIN_PATH.'/resbilling/sendbil3.php');
    }
    elseif($billing_id > 0){
      // Get owner objects without calculator commission
      include(ADMIN_PATH.'/resbilling/bilstorno_pack.php');
    }
    else{
      // Get owner objects without calculator commission
      include(ADMIN_PATH.'/resbilling/sendbil2.php');
    }
    break;
  case 1:
    // Check object is configured
    echo '<h2>'.$TEXT['RESBILLING'].'</h2>'."\n";
    if($single_obj > 0){
      $get_obj = $datapdo->query("SELECT * FROM `".TABLE_PREFIX."resbilling_objset` WHERE `object_id`='$single_obj' AND `last_modified`>'0'");
      if($datapdo->numRows($get_obj)>0){
        $obj = $datapdo->fetchRow($get_obj);
        $tpl_id = $obj['tpl'];
        $sector = $obj['section_id'];
        if($tpl_id == 1){
          if(count($res_ids)>0){
            include(ADMIN_PATH.'/resbilling/sendbil1.php');
          }
          else{
            if(!empty($errorres)){
              $admin->print_error($errorres.$MESSAGE['RESBILLING']['PLEASE_SELECTRES'],ADMIN_URL.'/reservations/reservations.php?object_id='.$single_obj.ARGSOJS.'section_id='.$sector);
            }
            else{
              $admin->print_success($MESSAGE['RESBILLING']['PLEASE_SELECTRES'],ADMIN_URL.'/reservations/reservations.php?object_id='.$single_obj.ARGSOJS.'section_id='.$sector);
            }
          }
        }
        else{
          include(ADMIN_PATH.'/resbilling/sendbil2.php');
        }
      }
      else{ $admin->print_success($MESSAGE['RESBILLING']['PLEASE_OBJECTSET'],ADMIN_URL.'/resbilling/index.php?object_id='.$single_obj.ARGSOJS.'bilaction=3'.ARGSOJS.'nextact=1',2); }
    }
    break;
  case 0:
  default:
    // Get list of biilings
    echo '<h2>'.$MENU['RESBILLING'].'</h2>'."\n";
    require_once(BC_PATH.'/lib/functions.php');
    include(ADMIN_PATH.'/resbilling/billinglist.php');
    break;
}

// Print admin footer
$admin->print_footer();
?>